%
%   MLCV Summer 2016
%   Homework Assignment 04 - Boosting
%
%   Exercise 1) Adaboost
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Read in the dataset
X = csvread([pwd '/banknote_auth/banknote_auth_data.csv']);
Y = csvread([pwd '/banknote_auth/banknote_auth_labels.csv']);

% Make all labels -1 and +1
labels = unique(Y);
Ytemp = Y;
Y(Ytemp==labels(1)) = -1;
Y(Ytemp==labels(2)) = 1;
clear Ytemp;


%% Creating the training and testing sets

trainingRatio = 0.5;
[ Xtrain, Ytrain, Xtest, Ytest ] = define_learningset(X, Y, trainingRatio);

% Displaying the training and testing sets
figure;
subplot(2,2,1);
hold on; axis square;
idx = Ytrain==1;
plot(Xtrain(idx,1), Xtrain(idx,2),'b*');
plot(Xtrain(~idx,1), Xtrain(~idx,2),'r*');
title('Training set');

subplot(2,2,2);
hold on; axis square;
idx = Ytest==1;
plot(Xtest(idx,1), Xtest(idx,2),'b*');
plot(Xtest(~idx,1), Xtest(~idx,2),'r*');
title('Testing set');


%% Adaboost
maxWeakLearners = 20;
Ntrain = size(Xtrain,1);
Ntest = size(Xtest, 1);

% Training and testing error rates
trainError = zeros(maxWeakLearners,1);
testError = zeros(maxWeakLearners,1);
for nwl=1:maxWeakLearners
    adaboostModel = adaboost_train(Xtrain, Ytrain, nwl);

    Predtrain = adaboost_predict(Xtrain, adaboostModel);
    trainError(nwl) = mean(Predtrain ~= Ytrain);

    Predtest = adaboost_predict(Xtest, adaboostModel);
    testError(nwl) = mean(Predtest ~= Ytest);
end


%%
subplot(2,2,3);
plot(1:maxWeakLearners,trainError);
axis([1,maxWeakLearners,0,1]);
title('Training Error');
xlabel('#weak classifiers');
ylabel('error rate');
grid on;

subplot(2,2,4); axis square;
plot(1:maxWeakLearners,testError);
axis([1,maxWeakLearners,0,1]);
title('Testing Error');
xlabel('#weak classifiers');
ylabel('error rate');
grid on;


%%
