% 
%   MLCV Winter 2015
%   Homework Assignment 03 - Gaussian Mixture Models
%
%   Exercise 2) K-Means and EM algorithm
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Read in the dataset
X = csvread([pwd '/fisher_iris_data.csv']);
Y = importdata([pwd '/fisher_iris_labels.csv']);
labelSet = unique(Y);
Ynum = cellfun(@(label) find(strcmp(label, labelSet)), Y, 'UniformOutput', 1);
numGaussians = length(labelSet);


%% Plot dataset
figure;
subplot(1,2,1);
mscatter(X);
title('Data without labels');
subplot(1,2,2);
mscatter(X, Y);
title('Data with true labels'); 


%% Exercise 2a and 2b - K-Means
scatterPlot = 0;
numEvals = 100;
kMeansPerf = zeros(numEvals,1);
kmeansSolutions = cell(numEvals,1);
for i=1:numEvals
    fprintf('K-Means Run %d\n', i);
    clusterIdx = mkmeans(X, numGaussians, scatterPlot);
    kMeansPerf(i) = mkmeanseval(X, Ynum, clusterIdx);
    fprintf('Accuracy: %.4f\n\n', kMeansPerf(i));
    kmeansSolutions{i} = clusterIdx;
end

hist(kMeansPerf)


%% Exercise 2c and 2d - Expectation Maximization
scatterPlot = 0;
numEvals = 100;
emPerf = zeros(numEvals,1); 
emSolutions = cell(numEvals,1);

% fixed symmetric covariance (supplied as a parameter)
Cov = cov(X);
for i=1:numEvals
    fprintf('EM Run %d\n', i);
    initModel = initWithKMeans(X, kmeansSolutions{i});
    gamma = mgmmEM(X, numGaussians, initModel, scatterPlot);
    [~,gmmIdx] = max(gamma, [], 2);
    emPerf(i) = mkmeanseval(X, Ynum, gmmIdx);
    emSolutions{i} = gmmIdx;
end

hist(emPerf)

