% 
%   MLCV Winter 2015
%   Homework Assignment 03 - Gaussian Mixture Models
%
%   Exercise 2b) K-Means algorithm evaluation
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


function [ acc ] = mkmeanseval( X, Y, Z )
%MKMEANSEVAL Summary of this function goes here
%   X - nxp matrix of data
%   Y - n-dimensional vector of true labels
%   Z - n-dimensional vector of predicted labels

[n,p] = size(X);

labelSet = unique(Y);
numLabels = length(labelSet);

assert(length(unique(Z)) == numLabels)

% Compute the true cluster means
means = zeros(numLabels, p);
for k=1:numLabels
    means(k,:) = mean(X(Y==k, :));
end

% Compute the assigned cluster means
assignedMeans = zeros(numLabels, p);
for k=1:numLabels
    assignedMeans(k,:) = mean(X(Z==k, :));
end

% Map assignment to nearest means
Zc = zeros(length(Z), 1);
mapped = false(numLabels,1);
for k=1:numLabels
    % Compute distances of assigned mean to true means
    dist = pdist2(assignedMeans(k,:), means);
    % Sort the distances and save the means indexes
    [~, sortedIdx] = sort(dist);
    
    % Try to map to a mean starting from nearest
    for i=1:length(sortedIdx)
        m = sortedIdx(i);  % pop a mean
        if ~mapped(m)      % if it is not mapped
            Zc(Z==k) = m;  % map it
            mapped(m) = 1; % mark it as mapped
            break;         % stop searching
        end
    end
end

assert(length(unique(Zc)) == numLabels)

acc = mean(Zc == Y);


end

