% 
%   MLCV Winter 2015
%   Homework Assignment 03 - Gaussian Mixture Models
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


function [ h ] = mscatter( X, varargin )
%MSCATTER Summary of this function goes here
%   Detailed explanation goes here

dim = size(X,2);
if dim < 2
    fprintf('Data Dimension lower than 2, no scatter plot!\n');
    return;
end    

labelsGiven = false;
if nargin > 1 && ~isempty(varargin{1})
    Y = varargin{1};
    if iscell(Y)
        labelSet = unique(Y);
        Y = cellfun(@(label) find(strcmp(label, labelSet)), Y, 'UniformOutput', 1);
    end
    labelsGiven = true;
end

markerType = 'filled';
if nargin > 2
    markerType = varargin{2};
end


if labelsGiven
    if dim == 2
        h = scatter(X(:,1), X(:,2), [], Y, markerType);
    else
        h = scatter3(X(:,1), X(:,2), X(:,3), [], Y, markerType);
    end
else
    if dim == 2
        h = scatter(X(:,1), X(:,2), markerType);
    else
        h = scatter3(X(:,1), X(:,2), X(:,3), markerType);
    end    
end

end

